﻿<%@ WebHandler Language="C#" Class="Handler" %>

using System;
using System.Web;
using Affirma.ThreeSharp;

public class Handler : IHttpHandler
{

    private readonly string awsAccessKeyId = "";
    private readonly string awsSecretAccessKey = "";
    private readonly string BUCKET_NAME = "";

    private HttpContext _context;
    private HttpContext Context
    {
        get { return _context; }
        set { _context = value; }
    }


    public void ProcessRequest(HttpContext context__1)
    {
        Context = context__1;
        string path = Context.Request.QueryString["path"];
        if (path == null)
        {
            return;
        }

        string pathToFile = HttpUtility.UrlDecode(path);
        string realS3PathToFile = SpecialUrlCharsHelperr.UrlEncode(pathToFile);

        // Force download
        // string fileExtension = VirtualPathUtility.GetExtension(pathToFile); 
        // this.ForceDownlodFile(realS3PathToFile, Affirma.ThreeSharp.ThreeSharpUtils.ConvertExtensionToMimeType(fileExtension), Context.Response);

        // do not download the file. Open in the window ;
        this.WriteFile(realS3PathToFile);
    }


    /// <summary>
    /// Forces browser to download the file
    /// </summary>
    /// <param name="pathToFile">Ppath to the file on the S3 server </param>
    /// <param name="contentType">The file content type</param>
    private void ForceDownlodFile(string pathToFile, string contentType, HttpResponse response)
    {
        response.Buffer = true;
        response.Clear();
        response.ContentType = string.IsNullOrEmpty(contentType) ? response.ContentType : contentType;
        string extension = VirtualPathUtility.GetExtension(pathToFile.Replace("http://", ""));

        if (extension != ".htm" && extension != ".html" && extension != ".xml")
        {
            response.AddHeader("content-disposition", "attachment; filename=" + VirtualPathUtility.GetFileName("/" + pathToFile));
        }

        using (Affirma.ThreeSharp.Model.ObjectGetRequest getRequest = new Affirma.ThreeSharp.Model.ObjectGetRequest(BUCKET_NAME, pathToFile))
        {
            using (Affirma.ThreeSharp.Model.ObjectGetResponse getResponse = S3Service.ObjectGet(getRequest))
            {
                response.BinaryWrite(getResponse.StreamResponseToBytes());
                response.Flush();
                response.End();
            }
        }
    }

    private void WriteFile(string pathToFile)
    {
        using (Affirma.ThreeSharp.Model.ObjectGetRequest getRequest = new Affirma.ThreeSharp.Model.ObjectGetRequest(BUCKET_NAME, pathToFile))
        {
            using (Affirma.ThreeSharp.Model.ObjectGetResponse getResponse = S3Service.ObjectGet(getRequest))
            {
                Context.Response.BinaryWrite(getResponse.StreamResponseToBytes());
                Context.Response.Flush();
                Context.Response.End();
            }
        }
    }

    public bool IsReusable
    {
        get { return false; }
    }

    private IThreeSharp S3Service
    {
        get
        {
            ThreeSharpConfig config = new ThreeSharpConfig();
            config.AwsAccessKeyID = awsAccessKeyId;
            config.AwsSecretAccessKey = awsSecretAccessKey;
            IThreeSharp service = new Affirma.ThreeSharp.Query.ThreeSharpQuery(config);

            return service;
        }
    }
}
